<div align="center">
<h1>TRX – Tomb Raider I & II: Community Edition</h1>

<a href="https://github.com/LostArtefacts/TRX/releases?q=tr1x+prerelease%3Afalse&expanded=true">
    <img src="data/download_tr1x.svg"/>
</a>
<a href="https://github.com/LostArtefacts/TRX/releases?q=tr2x+prerelease%3Afalse&expanded=true">
    <img src="data/download_tr2x.svg"/>
</a>
</div>

<hr/>

> [!NOTE]
>
> We've merged TR1X and TR2X into a single codebase, now renamed **TRX**.
>
> - TR1 and TR2 remain distinct with their own release cycles.
> - Config tools and TR1 installer remain separate.
> - Simplifies internal code merges and feature sharing, replacing **libtrx**.
>
> Thanks for your support!


Welcome to **TRX** – an open-source reimplementation of **Tomb Raider 1** and **Tomb Raider 2**, respectively. Both projects aim to enhance these classic games through decompilation and the implementation of open-source alternatives to proprietary components.

## TR1X - Tomb Raider 1
### Showcase
<table>
    <tr>
        <th>
            Restored braid
            <img src="docs/tr1/showcase/braid.jpg"/>
        </th>
        <th>
            Enemy health bar and UI scaling
            <img src="docs/tr1/showcase/enemy_health_bar_and_scaling.jpg"/>
        </th>
    </tr>
    <tr>
        <th>
            3D pickups
            <img src="docs/tr1/showcase/3d_pickups.jpg"/>
        </th>
        <th>
            Skybox support
            <img src="docs/tr1/showcase/skybox.jpg"/>
        </th>
    </tr>
    <tr>
        <th>
            Customizable draw distance
            <img src="docs/tr1/showcase/draw_distance.webp"/>
        </th>
        <th>
            Developer console
            <img src="docs/tr1/showcase/console.webp"/>
        </th>
    </tr>
    <tr>
        <th>
            Free camera
            <img src="docs/tr1/showcase/free_camera.jpg"/>
        </th>
        <th>
            PS1 UI and new graphics options
            <img src="docs/tr1/showcase/ps1_ui_and_gfx.jpg"/>
        </th>
    </tr>
</table>

### Download
Download the latest release:

<a href="https://github.com/LostArtefacts/TRX/releases?q=tr1x+prerelease%3Afalse&expanded=true">
    <img src="data/download_tr1x.svg"/>
</a>

See [the changelog](docs/tr1/CHANGELOG.md).

### Install Instructions
Please refer to the [detailed documentation](docs/tr1/).

## TR2X - Tomb Raider 2
### Decompilation Progress
Decompilation is currently complete, and we're shifting our focus towards
enriching the game with new features.

### Download
Download the latest release:

<a href="https://github.com/LostArtefacts/TRX/releases?q=tr2x+prerelease%3Afalse&expanded=true">
    <img src="data/download_tr2x.svg"/>
</a>

See [the changelog](docs/tr2/CHANGELOG.md).

### Install Instructions
Please refer to the [detailed documentation](docs/tr2/).


## Q&A

1. **Is the game fully playable from beginning to the end?**

    By all means! If you encounter a bug, please file a ticket.

2. **Can we get HD textures? Reflections? Other visual updates?**

    We hope so! Being able to introduce skyboxes to TR1 showed that quite
    literally sky is the limit. But great stuff takes time.

4. **Can I play this on Mac, Linux, Android...?**

    Currently supported platforms include Windows, Linux and macOS for both
    TR1X and TR2X.

5. **What's the relation to TR2Main?**

    Originally founded as TR1Main in 2021, our project flourished independently
    without sharing the code, with the shared brand concept existing only as an
    idea. To better represent this, we rebranded to Tomb1Main. In 2023, we
    further refined our identity by adopting the name TR1X. Meanwhile, TR2Main
    follows a completely separate and unique path, unconnected to our
    development work.
